VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmQSTATS 
   Caption         =   "This program calculates streamflow statistics from NWIS WEB RDB files"
   ClientHeight    =   5412
   ClientLeft      =   480
   ClientTop       =   480
   ClientWidth     =   8664
   Icon            =   "Qstats.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5412
   ScaleWidth      =   8664
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About QSTATS"
      Height          =   492
      Left            =   6960
      TabIndex        =   19
      ToolTipText     =   "Information about QSTATS"
      Top             =   120
      Width           =   1572
   End
   Begin VB.CheckBox cb3PLN 
      Caption         =   "Calculate 3-Parameter Lognormal Statistics"
      Enabled         =   0   'False
      Height          =   372
      Left            =   3600
      TabIndex        =   18
      ToolTipText     =   "Calculate statistics for the 3-parameter for the common logs of nonzero streamflows"
      Top             =   3000
      Value           =   1  'Checked
      Visible         =   0   'False
      Width           =   3012
   End
   Begin VB.CheckBox cbLmomlog 
      Caption         =   "Calculate Log10 L-Moments"
      Height          =   372
      Left            =   240
      TabIndex        =   17
      ToolTipText     =   "Calculate L-Moments for the common logs of nonzero streamflows"
      Top             =   3480
      Value           =   1  'Checked
      Visible         =   0   'False
      Width           =   2652
   End
   Begin VB.CheckBox cbLmom 
      Caption         =   "Calculate Arithmetic L-Moments"
      Height          =   372
      Left            =   240
      TabIndex        =   16
      ToolTipText     =   "Calculate L-Moments"
      Top             =   3000
      Value           =   1  'Checked
      Visible         =   0   'False
      Width           =   3132
   End
   Begin VB.CommandButton CmdFindFile 
      Caption         =   "Find RDB Files"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4080
      TabIndex        =   15
      Top             =   1680
      Visible         =   0   'False
      Width           =   1572
   End
   Begin VB.CommandButton CmdGetData 
      Caption         =   "Process Data"
      Height          =   495
      Left            =   6840
      TabIndex        =   12
      Top             =   3360
      Visible         =   0   'False
      Width           =   1692
   End
   Begin VB.TextBox Text2 
      Enabled         =   0   'False
      Height          =   375
      Left            =   5640
      TabIndex        =   11
      Text            =   "1"
      Top             =   3480
      Visible         =   0   'False
      Width           =   972
   End
   Begin VB.TextBox Text4 
      Enabled         =   0   'False
      Height          =   612
      Left            =   840
      TabIndex        =   10
      Text            =   "Input"
      Top             =   4080
      Visible         =   0   'False
      Width           =   7692
   End
   Begin VB.CommandButton CmdClose 
      Caption         =   "Close"
      Height          =   492
      Left            =   6840
      TabIndex        =   9
      Top             =   4800
      Width           =   1692
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   120
      Top             =   4800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox Text1 
      Enabled         =   0   'False
      Height          =   285
      Left            =   2760
      TabIndex        =   6
      Text            =   "01117500"
      Top             =   2400
      Visible         =   0   'False
      Width           =   5652
   End
   Begin VB.CommandButton CmdBatchFile 
      Caption         =   "Batch File"
      Height          =   375
      Left            =   6120
      TabIndex        =   5
      ToolTipText     =   "Use to process one or more daily streamflow files from a list in an input file"
      Top             =   1680
      Width           =   2415
   End
   Begin VB.CommandButton CmdOneFile 
      Caption         =   "Individual NWIS RDB file"
      Height          =   375
      Left            =   1200
      TabIndex        =   4
      ToolTipText     =   "Use to process one daily streamflow file"
      Top             =   1680
      Width           =   2412
   End
   Begin VB.Label Label4 
      Caption         =   "Number of Files:"
      Height          =   372
      Left            =   4080
      TabIndex        =   14
      Top             =   3480
      Visible         =   0   'False
      Width           =   1332
   End
   Begin VB.Label Label8 
      Caption         =   "Current Status:"
      Height          =   372
      Left            =   120
      TabIndex        =   13
      Top             =   4080
      Visible         =   0   'False
      Width           =   612
   End
   Begin VB.Line Line3 
      Visible         =   0   'False
      X1              =   120
      X2              =   8520
      Y1              =   2880
      Y2              =   2880
   End
   Begin VB.Label Label5 
      Caption         =   "Enter Station Number  (Must be valid 8-12 digit number)"
      Height          =   492
      Left            =   120
      TabIndex        =   8
      Top             =   2280
      Visible         =   0   'False
      Width           =   2052
   End
   Begin VB.Label Label6 
      Caption         =   "Input File Name: (All output files will be saved to this directory)"
      Height          =   492
      Left            =   240
      TabIndex        =   7
      Top             =   2280
      Visible         =   0   'False
      Width           =   2292
   End
   Begin VB.Label LabelA 
      Caption         =   $"Qstats.frx":058A
      Height          =   372
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   8052
   End
   Begin VB.Label Label3 
      Caption         =   "Specify:"
      Height          =   252
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   852
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   8520
      Y1              =   1440
      Y2              =   1440
   End
   Begin VB.Label Label2 
      Caption         =   "ggranato@usgs.gov  July 2007"
      Height          =   252
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   6012
   End
   Begin VB.Label Label1 
      Caption         =   "NWIS Streamflow Statistics (QSTATS--version 1.0)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.6
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6612
   End
End
Attribute VB_Name = "frmQSTATS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit  ' Requires programmer to declare all variables
' Public Arguments available anywhere
Public strOutDir As String        ' Input/Output File Directory
Public strErrFile As String       ' Error output file
Public strHeaderFile As String    ' NWIS WEB Header File Name
Public StrDataFile As String      ' NWIS WEB Data File Name
Public StrOutputFile As String    ' Program output file
Public StrGISFile As String       ' Program output to GIS long, lat etc. file
Public StrLMomFile As String      ' Program output L-moment file
Public StrLMomLogFile As String   ' Program output to Common Log L-moment file
Public Str3PLogFile As String     ' Program output to 3-Parameter Common Log file
Public intmode As Long         ' Mode 1= interactive 2= batch
' Arguments
Dim strStationNumber() As String  ' USGS station number
Dim strInFName As String          ' Input file name
Dim strOutFName As String         ' Output file name
Dim lngnumsta As Long             ' Number of stations

Private Sub Form_Load()
'
' Purpose:
' To initialize values
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' Functions
' bnCheckFile(strStaFile As String) As Boolean
' To check that file exists for processing or other action
'
' Arguments
ReDim strStationNumber(1)
strStationNumber(1) = "01117500"
strOutDir = App.Path
' Set mode to interactive
intmode = 1
End Sub
Private Sub CmdOneFile_Click()
'
' Purpose:
' To Activate window to obtain and check USGS Station Number
' History:
' Version 1.0 May 2004 by G.E. Granato
' Arguments
intmode = 1                          ' Set mode to one file
Me.Label6.Visible = False            ' Make other caption invisible
Me.Label5.Visible = True             ' Make appropriate caption visible
Me.Text1.Width = 1282                 ' Make textbox width appropriate for station number
Me.Text1.Visible = True              ' Make text box 1 visible
Me.Text1.Enabled = True              ' Enable text box 1  for input
Me.Text1.Text = strStationNumber(1)  ' Put example number in
Me.CmdBatchFile.Enabled = False      ' Disable file choice button
Me.CmdOneFile.Enabled = False        ' Disable file choice button
MsgBox "Please enter a valid 8-12 number USGS Streamflow Gaging Station Number"
Me.Text1.SetFocus                     ' Set Focus on textbox
Me.CmdFindFile.Visible = True         ' Activate next step
Me.CmdFindFile.Enabled = True
lngnumsta = 1
End Sub


Private Sub Text1_LostFocus()
'
' Purpose:
' To read and check station number from Input box text1.txt
' History:
' Version 1.0 May 2004 by G.E. Granato
' Subroutines
' Sub ChkSta(strStaNum As String, iEc as long, intmode as long)
' To read and check station number from text file
'
' Arguments
Dim Ec As Long                    ' Integer Error Code
Dim strStaNum As String
Ec = 0                               ' initialize error code
strStaNum = Text1.Text               ' take string value
Call ChkSta(strStaNum, Ec, intmode)    ' check string value
If Ec = 1 Then
 MsgBox "Station Number too short! Please enter a valid 8-12 number USGS Streamflow Gaging Station Number"
 Ec = 0
 Text1.SetFocus
 Exit Sub
ElseIf Ec = 2 Then
 MsgBox "Nonnumeric character encountered! Please enter a valid 8-12 number USGS Streamflow Gaging Station Number"
 Ec = 0
 Text1.SetFocus
 Exit Sub
ElseIf Ec = 3 Then
 MsgBox "Station Number too long! Please enter a valid 8-12 number USGS Streamflow Gaging Station Number"
 Ec = 0
 Text1.SetFocus
 Exit Sub
ElseIf Ec = 0 Then
 strStationNumber(1) = strStaNum      ' set station number array
 Label4.Visible = True                ' turn on NumSta label
 Text2.Visible = True                 ' turn on stations window
 Text2.Text = 1                       ' populate stations window
End If
End Sub
Private Sub CmdBatchFile_Click()
'
' Purpose:
' To obtain and check USGS Station Number Batch File
' History:
' Version 1.0 April 2004 by G.E. Granato
' Subroutines
' Sub ChkSta(strStaNum As String, iEc as long, intmode as long)
' To read and check station number from text file
'
' Arguments
Dim strTestName As String            ' Test Name Used to find directory
Dim strinsta As String               ' read input stations
Dim n1 As Long                    ' Integer count variable
Dim n2 As Long                    ' Integer count variable
Dim intEC As Long                 ' Integer Error Code1
Dim intErrCode As Long            ' Integer Error message code
Dim intfnum As Long               ' File unit number
' Actions
On Error GoTo Err_CmdBatchFile_Click:
intmode = 2                          ' Set mode to Batch file
Me.CmdBatchFile.Enabled = False      ' Disable file choice button
Me.CmdOneFile.Enabled = False        ' Disable file choice button
' Get input filename
strInFName = "StationFile.txt"
' specify title
CommonDialog1.DialogTitle = "Text file of USGS station numbers"
'specify available filter
CommonDialog1.Filter = "All Files (*.*)|*.*|Text Files" & _
  "(*.txt)|*.txt"
' Specify default filter
CommonDialog1.FilterIndex = 2
CommonDialog1.CancelError = True
CommonDialog1.FileName = strInFName
CommonDialog1.ShowOpen
strInFName = CommonDialog1.FileName
'get dir name
strTestName = CommonDialog1.FileTitle
' Get directory
n2 = Len(strTestName)
n1 = Len(strInFName)
n1 = n1 - n2
strOutDir = Left(strInFName, n1)
Call OpenOutFiles
' turn on status window
Me.Text4.Visible = True
Me.Label8.Visible = True
Me.Text4.Text = "Processing: " & strInFName
Me.Refresh
Me.MousePointer = 11 'or vbHourglass
' Open file and Read valid 8-digit station numbers
 'count number of potential stations
  Open strInFName For Input As #1
  lngnumsta = 0
  Do While EOF(1) = False
   Line Input #1, strinsta   'Read Line
   lngnumsta = lngnumsta + 1
  Loop
  Close #1
  n1 = 0
  ReDim strStationNumber(lngnumsta)
  lngnumsta = 0
  Open strInFName For Input As #1
 Do While EOF(1) = False
  ' read station numbers as text
    Line Input #1, strinsta
    Me.Text4.Text = "Processing file for: " & strinsta
    Me.Refresh
  ' Reset Error Code
    intEC = 0
    intErrCode = 0
  ' Check for valid values
    Call ChkSta(strinsta, intEC, intmode)    ' check string value
  ' If Bad value report and divert to 25
    If intEC <> 0 Then
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, strinsta, "Error bad file name"
    Close intfnum
    GoTo 25:
    End If
  ' Check that header file exists
  ' does the file exist and does it have any text?
    Call ChkFiles(strOutDir, strinsta, intmode, intErrCode)
    If intErrCode = 0 Then
     n1 = n1 + 1
     strStationNumber(n1) = strinsta
    Else
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, strinsta, "Error bad file name or empty file"
    Close intfnum
     GoTo 25:
    End If
25: Me.Text4.Text = n1
  lngnumsta = n1
  Loop
  Close #1
  Me.MousePointer = 1 'or vbArrow
' Update form
Me.Label5.Visible = False            ' Make other caption invisible
Me.Label6.Visible = True             ' Make appropriate caption visible
Me.Text1.Width = 5415                ' Make textbox width appropriate for path/file
Me.Text1.Visible = True              ' Make text box 1 visible
Me.Text1.Enabled = False             ' Disable text box 1  for input
Me.Text1.Text = strInFName           ' Put example number in
Me.cbLmom.Visible = True             ' Activate next step, lmoment checkbox
Me.cbLmomlog.Visible = True          ' Activate next step, lmoment checkbox
' Me.cb3PLN.Visible = True             ' Activate next step, 3-P lognormal checkbox ***Ken Eng Said Don't do it
Me.CmdGetData.Visible = True         ' Activate next step
Me.Label4.Visible = True             ' turn on NumSta label
Me.Text2.Visible = True              ' turn on NumSta box
Me.Text2.Text = lngnumsta            ' populate NumSta box
Me.CmdGetData.SetFocus               ' set focus to the get data button
Exit Sub
Err_CmdBatchFile_Click:
If Err = 32755 Then
 MsgBox "Choose Individual NWIS RDB file, Batch File, or Close"
 Me.CmdBatchFile.Enabled = True      ' Enable file choice button
 Me.CmdOneFile.Enabled = True        ' Enable file choice button
 Me.CmdClose.SetFocus
 Me.MousePointer = 1 'or vbArrow
ElseIf Err = 53 Then
 MsgBox "Error File Does not Exist Please Try Again"
 Me.CmdBatchFile.Enabled = True      ' Enable file choice button
 Me.CmdOneFile.Enabled = True        ' Enable file choice button
 Me.CmdClose.SetFocus
 Me.MousePointer = 1 'or vbArrow
Else
 MsgBox "Error on form: Please Quit and try again"
 Me.CmdClose.SetFocus
 Me.MousePointer = 1 'or vbArrow
Exit Sub
End If
End Sub

Private Sub CmdFindFile_Click()
'
' Purpose:
' To Find Stream Station Header and flow files
' eg 01117500H.txt and data file 01117500Q.txt for each station
' History:
' Version 1.0 May 2004 by G.E. Granato
' Attempt to obtain the input filenames
' Functions
' bnCheckFile(strStaFile As String) As Boolean
' To check that file exists for processing or other action
'
' Arguments
  Dim bnFileExists As Boolean  ' Check variable for file existance
  Dim strTestName As String    ' Dummy variable to extract directory name
  Dim StrErrMsg As String      ' Error Message
  Dim intN1 As Long         ' Dummy variable to extract directory name
  Dim intN2 As Long         ' Dummy variable to extract directory name
  Dim intMsgResult As Long  ' message box result
  Dim intH As Long          ' position of "H" in header file name
  Dim intErrCode As Long    ' file error code
'
  On Error GoTo Err_CmdFindFile_Click:
' GET HEADER FILE
' Freeze Station number file for editing
  Me.Text1.Enabled = False
  strStationNumber(1) = Me.Text1.Text
  strHeaderFile = strStationNumber(1) & "H.txt"
' specify title
10 CommonDialog1.DialogTitle = "Specify Header File Name"
 'specify available filter
   CommonDialog1.Filter = "All Files (*.*)|*.*|Text Files" & _
   "(*.txt)|*.txt"
 ' Specify default filter
  CommonDialog1.FilterIndex = 2
  CommonDialog1.CancelError = True
  CommonDialog1.FileName = strStationNumber(1) & "H.txt"
  CommonDialog1.ShowOpen
  strHeaderFile = CommonDialog1.FileName
 'get dir name
  strTestName = CommonDialog1.FileTitle
  Call PosString(strTestName, "H", intH)
  If intH < 2 Then
   MsgBox "Filename does not meet the format of stationnumberH.txt"
   Exit Sub
  Else
   intH = intH - 1
   strStationNumber(1) = Left$(strTestName, intH)
   Me.Text1.Text = strStationNumber(1)
  End If
' Get directory
  intN2 = Len(strTestName)
  intN1 = Len(strHeaderFile)
  intN1 = intN1 - intN2
  strOutDir = Left(strHeaderFile, intN1)
  Call OpenOutFiles
  ' Check for file existence
  bnFileExists = bnCheckFile(strHeaderFile)
  If bnFileExists = False Then
     StrErrMsg = "Error: Header File: " & Chr(13) & Chr(10) & _
     strHeaderFile & Chr(13) & Chr(10) & _
     "Does Not Exist."
     MsgBox StrErrMsg
     GoTo 10
  End If
  ' Check for file
  If FileLen(strHeaderFile) = 0 Then    'vb6 intrinsic file length function
     StrErrMsg = "Error: Header File: " & Chr(13) & Chr(10) & _
     strHeaderFile & Chr(13) & Chr(10) & _
     "Has no data."
     MsgBox StrErrMsg
     GoTo 10
  End If

   ' does the file exist and does it have any text?
   Call ChkFiles(strOutDir, strStationNumber(1), intmode, intErrCode)
   If (intErrCode <> 0) Then
    Me.CmdFindFile.Visible = True
    Me.CmdFindFile.Enabled = True
    Me.CmdFindFile.SetFocus
    Exit Sub
   End If
  
  
' GET DATA FILE
20 CommonDialog1.DialogTitle = "Specify Data File Name"
 'specify available filter
   StrDataFile = strStationNumber(1) & "Q.txt"
   CommonDialog1.Filter = "All Files (*.*)|*.*|Text Files" & _
   "(*.txt)|*.txt"
 ' Specify default filter
  CommonDialog1.FilterIndex = 2
  CommonDialog1.CancelError = True
  CommonDialog1.FileName = strOutDir & strStationNumber(1) & "Q.txt"
  CommonDialog1.ShowOpen
  StrDataFile = CommonDialog1.FileName
 ' Check for file existence
  bnFileExists = bnCheckFile(StrDataFile)
  If bnFileExists = False Then
     StrErrMsg = "Error: Data File: " & Chr(13) & Chr(10) & _
     StrDataFile & Chr(13) & Chr(10) & _
     "Does Not Exist."
     MsgBox StrErrMsg
     GoTo 20
  End If
  ' Check for file
  If FileLen(StrDataFile) = 0 Then    'vb6 intrinsic file length function
     StrErrMsg = "Error: Data File: " & Chr(13) & Chr(10) & _
     StrDataFile & Chr(13) & Chr(10) & _
     "Has no data."
     MsgBox StrErrMsg
     GoTo 20
  End If
  ' Move on to process data
    Me.CmdFindFile.Visible = False
    Me.cbLmom.Visible = True             ' Activate next step, lmoment checkbox
    Me.cbLmomlog.Visible = True             ' Activate next step, lmoment checkbox
    ' Me.cb3PLN.Visible = True             ' Activate next step, 3-P lognormal checkbox ***Ken Eng Said Don't do it
    Me.CmdGetData.Visible = True
    Me.CmdGetData.Enabled = True
    Me.CmdGetData.SetFocus
    Me.MousePointer = 1 'or vbArrow
  Exit Sub
Err_CmdFindFile_Click:
 If Err = 32755 Then
  intMsgResult = MsgBox("You chose to cancel. Exit program?", vbYesNo, "File Problem")
  If (intMsgResult = 6) Then       ' 6= vbYes  reset values and exit
   Me.CmdFindFile.Visible = False
   Me.CmdClose.SetFocus
   Me.MousePointer = 1 'or vbArrow
  ElseIf (intMsgResult = 7) Then   ' 7= vbNo So try again
   Me.MousePointer = 1 'or vbArrow
   Exit Sub
  End If
 Else
  MsgBox "Fatal Error on form, try again."
  Me.MousePointer = 1 'or vbArrow
 End If
End Sub
Private Sub CmdGetData_Click()
'
' Purpose:
' To Get Stream Station Header Information and combine it with
' Streamflow data/statistics to make a stream summary file
' Uses header file eg 01117500H.txt and data file 01117500Q.txt for each station
' History:
' Version 1.0 May 2004 by G.E. Granato
'
' Subroutines
' Sub ChkFiles(strOutDir As String, strStaNum As String, intimode as long, intErrCode as long)
' To check that header file and data file for station number
' exist and have some data
'
' Sub GetHeader(Strfname As String, strSite_no As String, strStation_nm As String, _
' strDec_lat_va As String, StrDec_long_va As String, strState_cd As String, strAlt_va As String, _
' strHUC_cd As String, strDArea_va As String, strCArea_va As String, lngHL As Long, intErrCode as long)
' To obtain & check header file information
'
' Sub GetQ(Strfname As String, StrSN As String, FPInQ, bdate As Date, edate As Date, _
'  lngQCount As Long, lngSkips As Long, lngZedQ As Long, interrcode as long)
' To open and obtain data from flow file
'
' Sub STATS01(RinQ as double, num As Long, avg as double, var as double, sdev as double, skew as double)
' Takes array RinQ and returns statistics
'
' Sub DoLMoments(sRinQ() as double, lnum As Long, sb0 as double, sb1 as double, sb2 as double, sb3 as double, _
' slam1 as double, slam2 as double, slam3 as double, slam4 as double, slcv as double, slskew as double, slKurt as double)
' Takes array sRinQ and returns l-moment statistics
'
' Sub ssort(Arr() as double, lngcnt As Long)
' Takes array Arr and array sixe lngcnt and sorts
'
' Functions
' Function GEGMED(indata() as double, lngcont As Long) as double
' take sorted array and array size find median
' Arguments
  Dim bnFileExists As Boolean  ' Check variable for file existance
  Dim tb As String             ' tab character
  Dim StrErrMsg As String      ' Error Message
  Dim StrArgLine As String     ' Input argument line
  Dim stroutstr As String      ' output string
  Dim Strfname As String       ' strfname -- File name
  Dim strSite_no As String     ' strSite_no-- Site identification number
  Dim strStation_nm As String  ' strStation_nm-- Site name
  Dim strDec_lat_va As String  ' strDec_lat_va-- Decimal latitude
  Dim StrDec_long_va As String ' strDec_long_va -- Decimal longitude
  Dim strState_cd As String    ' strState_cd -- State code
  Dim strAlt_va As String      ' strAlt_va -- Altitude of gage
  Dim strHUC_cd As String      ' strHUC_cd -- Hydrologic unit code
  Dim strDArea_va As String    ' strDArea_va -- Drainage area area or if not available Contributing drainage
  Dim strCArea_va As String    ' strCArea_va   -- Contributing drainage area or if not available Drainage area
  Dim strMsgStr As String      ' message box string
  Dim intErrCode As Long    ' Error message code
  Dim intfnum As Long       ' File unit number for error file
  Dim lngQCount As Long        ' lngQcount -- Number of recorded flows
  Dim lngSkips As Long         ' lngSkips -- Number of skips in the record
  Dim lngZedQ As Long          ' lngZedQ -- Number of zero flows
  Dim lngi As Long             ' count variable
  Dim lngj As Long             ' count variable
  Dim bdate As Date            ' bdate -- Begin Date
  Dim edate As Date            ' edate -- End Date
  Dim sLinAvg As Double        ' Linear average
  Dim sLinVar As Double        ' Linear variance
  Dim sLinSDev As Double       ' Linear standard deviation
  Dim sLinCOV As Double        ' Linear Coefficient of variation sdev/avg
  Dim sLinMed As Double        ' Median value
  Dim sLinSkew As Double       ' Linear skew coefficient
  Dim sL10Avg As Double        ' Log10 average
  Dim sL10Var As Double        ' Log10 variance
  Dim sL10SDev As Double       ' Log10 standard deviation
  Dim sL10Skew As Double       ' Log10 skew coefficient
  'Dim sL10COV as double        ' Log10 Coefficient of variation sdev/avg
  Dim sL10AvgPUA As Double     ' Log10 average per unit area
  Dim sL10SDevPUA As Double    ' Log10 standard deviation per unit area
  Dim sLinAvgPUA As Double     ' average per unit area
  Dim sLinSDEVPUA As Double    ' standard deviation per unit area
  Dim sLinMedPUA As Double     ' Median value per unit area
  Dim sL10Med As Double        ' Median value of non zero values
  Dim sL10MedPUA As Double     ' Median value per unit area of non zero values
  Dim sDArea_va As Double      ' strDArea_va -- Drainage area area or if not available Contributing drainage
  Dim sCArea_va As Double      ' strCArea_va   -- Contributing drainage area or if not available Drainage area
  Dim sFlowArea As Double      ' area used for flow per unit area
  Dim intEC As Long         ' Error code from subroutine
  Dim lngLogNum As Long               ' Number of log values (nonzero flows)
  Dim sZedRatio As Double               ' ratio of nonzero flows
  ' lmoment values
  Dim sb1 As Double   '1st Probability weighted moment
  Dim sb2 As Double    '2nd Probability weighted moment
  Dim sb3 As Double    '3rd Probability weighted moment
  Dim slam1 As Double  '1st l-moment =sbo
  Dim slam2 As Double  '2nd l-moment =2*sb1-sb0
  Dim slam3 As Double  '3rd l-moment =6*sb2-6*sb1+sb0
  Dim slam4 As Double  '4th l-moment =20*sb3-30*sb2+12*sb1-sb0
  Dim slcv As Double   'l-moment coefficient of variation slam2/slam1
  Dim slskew As Double  ' l-moment coefficient skewness slam3/slam2
  Dim slKurt As Double  ' l-moment coefficient skewness slam4/slam2
  Dim intfree As Long ' freefile
  Dim strlmline As String ' printline
  Dim sQLBE As Double     ' quantile lowebound estimator
  '
  Dim lngECount As Long   ' count of estimated values
  
  
  On Error GoTo cmdGetData_ERR:
  tb = Chr(9)
  ' turn on status window
  Me.Text4.Visible = True
  Me.Label8.Visible = True
  For lngi = 1 To lngnumsta
    Me.Refresh
    Me.Text4.Text = "Processing station: " & strStationNumber(lngi)
    Me.Text4.Refresh
' If interactive  processing individual file check for file existance
  If intmode = 1 Then
   ' Check header file contents Skip if a probem occurs
   intErrCode = 0
   lngHeadLine = 0
   Call GetHeader(strHeaderFile, strSite_no, strStation_nm, strDec_lat_va, StrDec_long_va, _
   strState_cd, strAlt_va, strHUC_cd, strDArea_va, strCArea_va, lngHeadLine, intErrCode)
   If intErrCode > 0 Then
    strMsgStr = "Warning problem with header file please check line: " & lngHeadLine
    MsgBox strMsgStr, , " Error!"
   ElseIf intErrCode < 0 Then
    strMsgStr = "Fatal Error: Header file not read please try again check line: " & lngHeadLine
    MsgBox strMsgStr, , " Error!"
    Me.CmdGetData.Visible = False
    Me.CmdClose.SetFocus
    Exit Sub
   End If
   If strSite_no <> strStationNumber(1) Then
    strMsgStr = "Station number in header file does not match specified station number. Check line: " & lngHeadLine
    MsgBox strMsgStr, , " Error!"
    Me.CmdGetData.Visible = False
    Me.CmdClose.SetFocus
    Exit Sub
   End If
   ' Check drainage area
      ' Check drainage area for calculations
     strDArea_va = Trim(strDArea_va)
     intEC = 0
     Call ChkNumber(strDArea_va, intEC)
     If intEC = 0 Then
      sDArea_va = strDArea_va
     Else
      MsgBox "Warning problem with data file, station drainage area does not exist please check"
      Exit Sub
     End If
   strStation_nm = UCase$(strStation_nm)
   Me.MousePointer = 11 'or vbHourglass
   ' check data file skip if a problem occurs
   intErrCode = 0
   lngDataLine = 0
   Call GetQ(StrDataFile, strStationNumber(1), FPInQ, LFPInQ, bdate, edate, lngQCount, lngSkips, lngZedQ, lngDataLine, intErrCode, lngECount)
   ' get number of non zero flows and zero flow ratio
   lngLogNum = lngQCount - lngZedQ
   sZedRatio = 1# - ((lngLogNum * 1#) / (lngQCount * 1#))
   Me.MousePointer = 1 'or ccArrow
   If intErrCode = 1 Then
   strMsgStr = "Warning problem with data file. Please check line: " & lngDataLine
    MsgBox strMsgStr, , "Error!"
   ElseIf intErrCode = 2 Then
    strMsgStr = "Fatal Error: Data file not read please try again. See line: " & lngDataLine
    MsgBox strMsgStr, , "Error!"
    Me.CmdGetData.Visible = False
    Me.CmdClose.SetFocus
    Exit Sub
   ElseIf intErrCode = 6 Then
    strMsgStr = "Fatal Error: Data file station numbers do not equal specified station number, please try again. See line: " & lngDataLine
    MsgBox strMsgStr, , "Error!"
    Me.CmdGetData.Visible = False
    Me.CmdClose.SetFocus
    Exit Sub
   End If
' If batch file processing go through data file by file
  Else
   ' Check header file contents Skip if a probem occurs
   'Append folder slash if necessary
   If Right$(strOutDir, 1) <> "\" Then strOutDir = strOutDir & "\"
   strHeaderFile = strOutDir & strStationNumber(lngi) & "H.txt"
   StrDataFile = strOutDir & strStationNumber(lngi) & "Q.txt"
   intErrCode = 0
   lngHeadLine = 0
   Call GetHeader(strHeaderFile, strSite_no, strStation_nm, strDec_lat_va, StrDec_long_va, _
   strState_cd, strAlt_va, strHUC_cd, strDArea_va, strCArea_va, lngHeadLine, intErrCode)
   If intErrCode <> 0 Then
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, strHeaderFile, "Error in header file, Check Data"
    Close intfnum
   End If
   strStation_nm = UCase$(strStation_nm)
    If strSite_no <> strStationNumber(lngi) Then
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, strHeaderFile, "Station number in header file does not match specified station number."
    Close intfnum
    GoTo 95:
    Exit Sub
   End If
   ' Check drainage area for calculations
     strDArea_va = Trim(strDArea_va)
     intEC = 0
     Call ChkNumber(strDArea_va, intEC)
     If intEC = 0 Then
      sDArea_va = strDArea_va
     Else
      intfnum = FreeFile
      Open strErrFile For Append As intfnum
      Print #intfnum, strHeaderFile, "Warning problem with header file station drainage area does not exist please check"
      Close intfnum
     End If
   Me.MousePointer = 11 'or vbHourglass
   ' check data file skip if a problem occurs
   intErrCode = 0
   lngDataLine = 0
   Call GetQ(StrDataFile, strStationNumber(lngi), FPInQ, LFPInQ, bdate, edate, lngQCount, lngSkips, lngZedQ, lngDataLine, intErrCode, lngECount)
   ' get number of non zero flows and zero flow ratio
   lngLogNum = lngQCount - lngZedQ
   sZedRatio = 1# - ((lngLogNum * 1#) / (lngQCount * 1#))
   Me.MousePointer = 1 'or ccArrow
   If intErrCode = 1 Then             ' something questionable in data file
     intfnum = FreeFile
     Open strErrFile For Append As intfnum
     Print #intfnum, strHeaderFile, "Warning problem with data file please check line " & lngDataLine
     Close intfnum
   ElseIf intErrCode = 2 Then          'fatal error in data file
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, StrDataFile, "Fatal Error: Data file not read please try again. See line: "; lngDataLine
    Close intfnum
    GoTo 95:
   ElseIf intErrCode = 6 Then
    intfnum = FreeFile
    Open strErrFile For Append As intfnum
    Print #intfnum, StrDataFile, "Fatal Error: Data file station numbers do not equal specified station number. See line: "; lngDataLine
    Close intfnum
    GoTo 95:
   End If
 End If
       ' Check contributing drainage area for calculations
     strCArea_va = Trim(strCArea_va)
     intEC = 0
     Call ChkNumber(strCArea_va, intEC)
     If intEC = 0 Then
      sCArea_va = strCArea_va
      If (sDArea_va > sCArea_va) And (sCArea_va <> 0#) Then
       sFlowArea = sCArea_va
      Else
       sFlowArea = sDArea_va
       If (sCArea_va = 0#) Then strCArea_va = strDArea_va
      End If
     Else
      sFlowArea = sDArea_va
      sCArea_va = sDArea_va
      strCArea_va = strDArea_va
     End If
    Me.Text4.Text = "Processing file: " & StrDataFile
    Me.Text4.Refresh
    If lngi = 1 Then
     Call PutFileHeader(StrOutputFile)
     Call PutGISHeader(StrGISFile)
     If Me.cbLmom.Value = 1 Then Call PutLMomHeader(StrLMomFile) ' Print lmoments
     If Me.cbLmomlog.Value = 1 Then Call PutLMomLogHeader(StrLMomLogFile) ' Print log lmoments
    ' If Me.cb3PLN.Value = 1 Then Call Put3PLogHeader(Str3PLogFile)   ' Print 3-p lognormal ***Ken Eng Said Don't do it
  End If
  ' get data statistics
    Me.MousePointer = 11 'or vbHourglass
  ' get arithmatic statistics
    Call STATS01(FPInQ, lngQCount, sLinAvg, sLinVar, sLinSDev, sLinSkew)

    
    Me.MousePointer = 1 'or ccArrow
    sLinCOV = sLinSDev / sLinAvg
  ' sort array to obtain median
    Me.MousePointer = 11 'or vbHourglass
    ' Call ssort(FPInQ, lngQCount)
    QuickSortArray FPInQ, 1, lngQCount
    sLinMed = GEGMED(FPInQ, lngQCount)
    
    
    If Me.cbLmom.Value = 1 Then 'calculate and print lmoments
     Call DoLMoments(FPInQ, lngQCount, sLinAvg, sb1, sb2, sb3, slam1, slam2, slam3, slam4, slcv, slskew, slKurt)
      intfree = FreeFile
      Open StrLMomFile For Append As intfree
       strlmline = strSite_no & tb & strStation_nm & tb & lngQCount & tb & Format(sLinAvg, "###0.0000##") & tb _
       & Format(sb1, "###0.0000##") & tb & Format(sb2, "###0.0000##") & tb & Format(sb3, "###0.0000##") & _
       tb & Format(slam1, "###0.0000##") & tb & Format(slam2, "###0.0000##") & _
       tb & Format(slam3, "###0.0000##") & tb & Format(slam4, "###0.0000##") & tb & _
       Format(slcv, "###0.0000##") & tb & Format(slskew, "###0.0000##") & tb & Format(slKurt, "###0.0000##")
      Print #intfree, strlmline
      Close (intfree)
    End If
    
    Me.MousePointer = 1 'or ccArrow
    '
    Me.MousePointer = 11 'or vbHourglass
  '
  ' get log10 statistics
  ' Only non-zero flows included
     For lngj = 1 To lngLogNum
      LFPInQ(lngj) = Log(LFPInQ(lngj)) / Log(10#)
     Next lngj
    Call STATS01(LFPInQ, lngLogNum, sL10Avg, sL10Var, sL10SDev, sL10Skew)
    Me.MousePointer = 1 'or ccArrow
  ' Get Median of nonzero values
    QuickSortArray LFPInQ, 1, lngLogNum
    sL10Med = GEGMED(LFPInQ, lngLogNum)
        
    If Me.cbLmomlog.Value = 1 Then 'calculate and print lmoments
     Call DoLMoments(LFPInQ, lngLogNum, sL10Avg, sb1, sb2, sb3, slam1, slam2, slam3, slam4, slcv, slskew, slKurt)
      intfree = FreeFile
      Open StrLMomLogFile For Append As intfree
       strlmline = strSite_no & tb & strStation_nm & tb & lngLogNum & tb & Format(sL10Avg, "###0.0000##") & tb _
       & Format(sb1, "###0.0000##") & tb & Format(sb2, "###0.0000##") & tb & Format(sb3, "###0.0000##") & _
       tb & Format(slam1, "###0.0000##") & tb & Format(slam2, "###0.0000##") & _
       tb & Format(slam3, "###0.0000##") & tb & Format(slam4, "###0.0000##") & tb & _
       Format(slcv, "###0.0000##") & tb & Format(slskew, "###0.0000##") & tb & Format(slKurt, "###0.0000##")
      Print #intfree, strlmline
      Close (intfree)
    End If
     
  '
  ' retransform log10 statistics to arithmetic space
    'If sL10Avg <> 0 Then
    ' sL10COV = sL10SDev / sL10Avg
    ' Else
    ' sL10COV = sL10SDev / 0.000001
    ' End If
    sL10Avg = 10# ^ sL10Avg
    sL10Med = 10# ^ sL10Med
    sL10Var = 10# ^ sL10Var
    sL10SDev = 10# ^ sL10SDev
  ' Generate flow per unit area
  ' Note Bill Kirby USGS OSW said to do this outside original statistics of data
    sL10AvgPUA = sL10Avg / sFlowArea
    sLinAvgPUA = sLinAvg / sFlowArea
    sLinSDEVPUA = sLinSDev / sFlowArea
    sLinMedPUA = sLinMed / sFlowArea
    sL10MedPUA = sL10Med / sFlowArea
  ' Append flows per unit area to the geographic file:
    stroutstr = StrDec_long_va & tb & strDec_lat_va & tb & strSite_no & tb & strStation_nm & tb & _
    strAlt_va & tb & strDArea_va & tb & Format(sFlowArea, "##0.00") & tb & lngQCount & tb & _
    Format(sZedRatio, "###0.0000##") & tb & Format(sL10AvgPUA, "###0.0000##") & tb & Format(sL10SDev, "###0.0000##") & tb & _
    Format(sL10Skew, "###0.0000##") & tb & Format(sL10MedPUA, "###0.0000##") & tb & _
    Format(sLinAvgPUA, "###0.0000##") & tb & Format(sLinSDEVPUA, "###0.0000##") & tb & Format(sLinSkew, "###0.0000##") & _
    tb & Format(sLinMedPUA, "###0.0000##")
    intfnum = FreeFile
    Open StrGISFile For Append As intfnum
    Print #intfnum, stroutstr
    Close intfnum
  ' Append data to output file
    stroutstr = strSite_no & tb & strStation_nm & tb & strDec_lat_va & tb & StrDec_long_va & tb & strState_cd & _
    tb & strHUC_cd & tb & strDArea_va & tb & strCArea_va & tb & Format(bdate, "YYYY-MM-DD") & tb & _
    Format(edate, "YYYY-MM-DD") & tb & lngQCount & tb & lngSkips & tb & lngZedQ & tb & Format(sZedRatio, "###0.0000##") _
    & tb & Format(sLinAvg, "#0.00") & tb & Format(sLinSDev, "#0.000") & tb & Format(sLinSkew, "#0.000") & tb & _
    Format(sLinMed, "#0.00") & tb & Format(sL10Avg, "#0.00") & tb & Format(sL10SDev, "#0.000") & tb & _
    Format(sL10Skew, "#0.0000") & tb & lngECount
    intfnum = FreeFile
    Open StrOutputFile For Append As intfnum
    Print #intfnum, stroutstr
    Close intfnum
    ' 3 parameter lognormal
    '
    '***Ken Eng Said Don't do it
    Me.cb3PLN.Value = 0
    If Me.cb3PLN.Value = 1 Then
     ReDim LF3PInQ(lngLogNum) As Double 'nonzero input flow values
     ' quantile-lower-bound estimator for 3-parameter lognormal distribution
     ' sL10Med already retransformed
     sQLBE = ((10#) ^ LFPInQ(1)) + ((10#) ^ LFPInQ(lngLogNum)) - ((sL10Med) * 2#)
     If sQLBE <> 0 Then
      sQLBE = (((10#) ^ LFPInQ(1)) * ((10#) ^ LFPInQ(lngLogNum)) - ((sL10Med * sL10Med))) / sQLBE
     Else
      sQLBE = 0
     End If
    ' get 3-plog10 statistics
    ' Only non-zero flows included
     For lngj = 1 To lngLogNum
      LF3PInQ(lngj) = Log(((10#) ^ LFPInQ(lngj)) - sQLBE) / Log(10#)
     Next lngj
     Call STATS01(LF3PInQ, lngLogNum, sL10Avg, sL10Var, sL10SDev, sL10Skew)
     sL10Avg = 10# ^ sL10Avg
     sL10SDev = 10# ^ sL10SDev
     stroutstr = strSite_no & tb & strStation_nm & tb & lngLogNum & tb & lngZedQ & tb & Format(sQLBE, "#0.000") & tb & _
     Format(sL10Avg, "#0.00") & tb & Format(sL10SDev, "#0.000") & tb & Format(sL10Skew, "#0.0000")
     intfnum = FreeFile
     Open Str3PLogFile For Append As intfnum
     Print #intfnum, stroutstr
     Close intfnum
    End If
95: Next lngi
    Me.Text4.Text = "See: " & StrOutputFile
    Me.Text4.Refresh
    Me.CmdClose.SetFocus
    Me.CmdGetData.Enabled = False
'    Me.cb3PLN.Enabled = False  ** Ken Eng said don't do it
    Me.cbLmom.Enabled = False
    Me.cbLmomlog.Enabled = False
    
  Exit Sub
    
cmdGetData_ERR:
  StrErrMsg = "Error: " & Err & vbCrLf & "Type of Error: " & Error & vbCrLf & "Fatal Error on form, close program, check input files, and try again."
  MsgBox StrErrMsg, vbExclamation, "Error!"
  Me.CmdClose.SetFocus
  Me.MousePointer = 1 'or ccArrow
End Sub
Private Sub cmdAbout_Click()
'
' Purpose:
' Program Information
' History:
' Version 1.0 Feb. 2007 by G.E. Granato
' Arguments
Dim strMsgStr As String

strMsgStr = "NWIS Streamflow Statistics (QSTATS--version 1.0)" & vbCrLf & _
"A program that calculates streamflow statistics " & vbCrLf & _
"from NWIS Web Average-Daily Streamflow(Q)" & vbCrLf & _
"files obtained and reformatted in RDB Format with GNWISQ" & vbCrLf & _
"" & vbCrLf & _
"By Gregory E. Granato" & vbCrLf & _
"U.S. Geological Survey " & vbCrLf & _
"ggranato@usgs.gov" & vbCrLf & _
"" & vbCrLf & _
"Prepared in cooperation with the" & vbCrLf & _
"U.S. Department of Transportation" & vbCrLf & _
"Federal Highway Administration" & vbCrLf & _
"Office of Natural and Human Environment" & vbCrLf & _
"" & vbCrLf & _
"2007 Version 1.0.0 " & vbCrLf

MsgBox strMsgStr, vbInformation, "About QSTATS:"

End Sub

Private Sub CmdClose_Click()
'
' Purpose:
' To Eliminate Empty Error File and Exit Application
' History:
' Version 1.0 May 2004 by G.E. Granato
' Functions
' bnCheckFile(strStaFile As String) As Boolean
' To check that file exists for processing or other action
'
' Arguments
Dim bnFileExists As Boolean     ' Check variable for file existance
Dim StrErrMsg As String         ' Error Message
On Error GoTo Err_CmdClose_Click:
' Check if error file exists
bnFileExists = bnCheckFile(strErrFile)
If bnFileExists = False Then
 End
Else
 'check if file empty
 If FileLen(strErrFile) = 0 Then    'vb6 intrinsic file length function
  Kill (strErrFile)                 'vb6 intrinsic file delete function
 Else
 ' Warn the user that a file processing error has occured
  StrErrMsg = "Errors occured check error file:" & strErrFile
  MsgBox StrErrMsg
 End If
End If
'End Program
End
Err_CmdClose_Click:
End
End Sub

Private Sub OpenOutFiles()
'
' Purpose:
' To open output files in the same directory as the input files
' History:
' Version 1.0 May 2004 by G.E. Granato
' Functions
' bnCheckFile(strStaFile As String) As Boolean
' To check that file exists for processing or other action
'
' Arguments
Dim bnFileExists As Boolean  ' Check variable for file existance
Dim interrfile As Long   'if file exists add number to filename
Dim intoutfile As Long   'if file exists add number to filename
Dim intGISfile As Long   'if file exists add number to filename
Dim intlmomfile As Long   'if file exists add number to filename

interrfile = 0
intoutfile = 0
intGISfile = 0
intlmomfile = 0
'Append folder slash if necessary
If Right$(strOutDir, 1) <> "\" Then strOutDir = strOutDir & "\"

' Set Output File Name
  StrOutputFile = strOutDir & "QStatsDatFile" & "0.txt"
  intoutfile = 0
10: bnFileExists = bnCheckFile(StrOutputFile)
    If bnFileExists = True Then
     intoutfile = intoutfile + 1
     StrOutputFile = strOutDir & "QStatsDatFile" & intoutfile & ".txt"
     GoTo 10:
    End If
' Set Error File Name
   strErrFile = strOutDir & "QStatsErrFile" & intoutfile & ".txt"
   bnFileExists = bnCheckFile(strErrFile)
   If bnFileExists = True Then Kill strErrFile
' Set GIS Output File Name
  StrGISFile = strOutDir & "QStatsGISFile" & intoutfile & ".txt"
  bnFileExists = bnCheckFile(StrGISFile)
    If bnFileExists = True Then Kill StrGISFile
  If Me.cbLmom.Value = 1 Then
'  Set Output File Name
   StrLMomFile = strOutDir & "QStatsLMomFile" & intoutfile & ".txt"
   bnFileExists = bnCheckFile(StrLMomFile)
   If bnFileExists = True Then Kill StrLMomFile
  End If
  If Me.cbLmomlog.Value = 1 Then
'  Set Output File Name
   StrLMomLogFile = strOutDir & "QStatsLMomLogFile" & intoutfile & ".txt"
   bnFileExists = bnCheckFile(StrLMomLogFile)
   If bnFileExists = True Then Kill StrLMomLogFile
  End If
' Set Output File Name
' ** Ken Eng said don't do it
  Me.cb3PLN.Value = 0
  
  If Me.cb3PLN.Value = 1 Then
   Str3PLogFile = strOutDir & "QStats3PLogFile" & intoutfile & ".txt"
   bnFileExists = bnCheckFile(Str3PLogFile)
   If bnFileExists = True Then Kill Str3PLogFile
  End If
End Sub
